using System;
using System.Collections.Generic;
using System.Text;
using System.Windows;
using System.Windows.Controls;
using System.Windows.Data;
using System.Windows.Documents;
using System.Windows.Input;
using System.Windows.Media;
using System.Windows.Media.Imaging;
using System.Windows.Navigation;
using System.Windows.Shapes;

namespace ObjectReferenceSample
{
    public partial class StoogeControl : UserControl
    {
        public StoogeControl()
        {
            InitializeComponent();
        }

        #region StoogeName

        /// <summary>
        /// StoogeName Dependency Property
        /// </summary>
        public static readonly DependencyProperty StoogeNameProperty =
            DependencyProperty.Register("StoogeName", typeof(string), typeof(StoogeControl),
                new FrameworkPropertyMetadata((string)null, 
                    new PropertyChangedCallback(OnStoogeNameChanged)));

        /// <summary>
        /// Gets or sets the StoogeName property.
        /// </summary>
        /// <remarks>
        /// 
        /// </remarks>
        public string StoogeName
        {
            get { return (string)GetValue(StoogeNameProperty); }
            set { SetValue(StoogeNameProperty, value); }
        }

        /// <summary>
        /// Handles changes to the StoogeName property.
        /// </summary>
        private static void OnStoogeNameChanged(DependencyObject d, DependencyPropertyChangedEventArgs e)
        {
            ((StoogeControl)d).OnStoogeNameChanged(e);
        }

        /// <summary>
        /// Provides derived classes an opportunity to handle changes to the StoogeName property.
        /// </summary>
        protected virtual void OnStoogeNameChanged(DependencyPropertyChangedEventArgs e)
        {
        }

        #endregion

    }
}